﻿// Bedrich Said
// startovni cislo: 46
// kategorie: mladez

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int gameId = 0;     //ID cislo hry 1-1000000000
        string[,] pole = new string[32, 32];  //mapa robota Leraka
        int roboX = 0;      //souradnice X robota
        int roboY = 0;      //souradnice Y robota
        char roboRot = 'N'; //smer robota na mape {N,S,V,Z}
        string pohyby;      //mnozina pohybu dalsiho tahu
        string sURL;        //pozadavek na server

        private void button1_Click(object sender, EventArgs e)
        {
            gameText.Text = "Hra byla odstartovana.";
            sURL = addressBox.Text + "start";

            WebRequest wrGETURL;
            wrGETURL = WebRequest.Create(sURL);

            WebProxy myProxy = new WebProxy("myproxy", 8000);
            myProxy.BypassProxyOnLocal = true;

            wrGETURL.Proxy = WebProxy.GetDefaultProxy();

            Stream objStream;
            objStream = wrGETURL.GetResponse().GetResponseStream();

            StreamReader objReader = new StreamReader(objStream);

            string sLine = "";
            int i = 0;

            while (sLine != null)
            {
                i++;
                sLine = objReader.ReadLine();
                if (sLine != null)
                {
                    if (i == 1) //ziskani ID
                    {
                        gameId = Convert.ToInt32(sLine);
                    }
                    if (i > 1 && i < 22)    //ziskani mapy
                    {
                        textBox1.Text += sLine;
                        textBox1.Text += "\r\n";
                        for (int a = 0; a < 20; a++)
                        {
                            pole[i - 2, a] = sLine[a].ToString();
                        }
                    }
                    if (i == 22)    //nacteni souradnic robota
                    {
                        string cislo = "";
                        int poce = 0;
                        while (sLine[poce] != ' ')
                        {
                            char x = sLine[poce];
                            cislo += x.ToString();
                            poce++;
                        }
                        roboX = Convert.ToInt32(cislo);
                        cislo = "";
                        poce++;
                        while (sLine[poce] != ' ')
                        {
                            char x = sLine[poce];
                            cislo += x.ToString();
                            poce++;
                        }
                        roboY = Convert.ToInt32(cislo);
                        roboRot = sLine[poce+1];
                    }
                    if (i == 23)    //nacreni mnoziny tahu
                    {
                        pohyby = sLine;
                        textTahy.Text = sLine;
                    }
                }
            }
            numX.Value = roboX;
            numY.Value = roboY;
            textRot.Text = roboRot.ToString();

            //pictureBox painting

            /*int pw = pictureBox1.Size.Width;
            int ph = pictureBox1.Size.Height;
            int w = pictureBox1.Size.Width / 2;
            int h = pictureBox1.Size.Height / 2;
            Graphics objGraphics = pictureBox1.CreateGraphics();
            Pen pen = new Pen(Color.Black);
            objGraphics.DrawLine(pen, 0, h, pw, h);
            objGraphics.DrawLine(pen, w, 0, w, ph);
            Rectangle rect = new Rectangle();
            rect.Height = 100;
            rect.Width = 100;
            pen.Width = 10;
            objGraphics.DrawRectangle(pen, rect);*/
        }

        private void NextBut_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            string sURL;
            sURL = addressBox.Text + "kolo?id=" + gameId + "&pohyby=" + textTahy.Text;

            WebRequest wrGETURL;
            wrGETURL = WebRequest.Create(sURL);

            WebProxy myProxy = new WebProxy("myproxy", 8000);
            myProxy.BypassProxyOnLocal = true;

            wrGETURL.Proxy = WebProxy.GetDefaultProxy();

            Stream objStream;
            objStream = wrGETURL.GetResponse().GetResponseStream();

            StreamReader objReader = new StreamReader(objStream);

            string sLine = "";
            int i = 0;

            while (sLine != null)
            {
                i++;
                sLine = objReader.ReadLine();
                if (sLine != null)
                {
                    if (i == 1) //ziskani ID
                    {
                        if (sLine != gameId.ToString())
                        {
                            gameText.Text = sLine;
                        }
                        else
                        {
                            gameId = Convert.ToInt32(sLine);
                        }
                    }
                    if (i > 1 && i < 22)    //ziskani mapy
                    {
                        textBox1.Text += sLine;
                        textBox1.Text += "\r\n";
                        for (int a = 0; a < 20; a++)
                        {
                            pole[i - 2, a] = sLine[a].ToString();
                        }
                    }
                    if (i == 22)    //nacteni souradnic robota
                    {
                        string cislo = "";
                        int poce = 0;
                        while (sLine[poce] != ' ')
                        {
                            char x = sLine[poce];
                            cislo += x.ToString();
                            poce++;
                        }
                        roboX = Convert.ToInt32(cislo);
                        cislo = "";
                        poce++;
                        while (sLine[poce] != ' ')
                        {
                            char x = sLine[poce];
                            cislo += x.ToString();
                            poce++;
                        }
                        roboY = Convert.ToInt32(cislo);
                        roboRot = sLine[poce + 1];
                    }
                    if (i == 23)    //nacreni mnoziny tahu
                    {
                        pohyby = sLine;
                        textTahy.Text = sLine;
                    }
                }
            }
            numX.Value = roboX;
            numY.Value = roboY;
            textRot.Text = roboRot.ToString();
        }

        private void textTahy_TextChanged(object sender, EventArgs e)
        {
            
        }

        private void Spocitat_Click(object sender, EventArgs e)
        {
            string sLine = textTahy.Text;
            int X = roboX;
            int Y = roboY;
            int newX = 0;
            int newY = 0;
            for (int i = 0; i < sLine.Count(); i++)
            {
                int posun = 0;
                if (sLine[i] == '1')
                    posun = 1;
                else if (sLine[i] == '2')
                    posun = 2;
                else if (sLine[i] == '3')
                    posun = 3;
                else if (sLine[i] == 'Z')
                    posun = -1;

                int rot = 0;
                if (roboRot == 'S')
                    rot = 0;
                else if (roboRot == 'V')
                    rot = 1;
                else if (roboRot == 'J')
                    rot = 2;
                else if (roboRot == 'Z')
                    rot = 3;

                if (sLine[i] == 'L')
                    rot--;
                else if (sLine[i] == 'R')
                    rot++;

                rot = (rot + 40) % 4;

                if (rot == 0)
                {
                    newX = X;
                    newY = Y - posun;
                }
                if (rot == 1)
                {
                    newX = X + posun;
                    newY = Y;
                }
                if (rot == 2)
                {
                    newX = X;
                    newY = Y + posun;
                }
                if (rot == 3)
                {
                    newX = X - posun;
                    newY = Y;
                }

                if (pole[newX, newY] == "X")
                {
                    newX = X;
                    newY = Y;
                }
                else if (pole[newX, newY] == "#")
                {
                    newX = -1;
                    newY = -1;
                }

                if (pole[newX, newY] == "<")
                {
                    newX--;
                }
                else if (pole[newX, newY] == ">")
                {
                    newX++;
                }
                else if (pole[newX, newY] == "^")
                {
                    newY--;
                }
                else if (pole[newX, newY] == "v")
                {
                    newY++;
                }
                X = newX;
                Y = newY;

            }
            futureX.Value = X;
            futureY.Value = Y;
        }
    }
}
